// pages/message/message.js
const app = getApp()
var host = app.globalData.host;
const $api = require('../../utils/api.js').API;
var timer;
Page({

    /**
     * 页面的初始数据
     */
    data: {
        focus:false,
        scrollTop:0,
        template_id:"S7423qLZ0QBhHAI6lfqYwc6CILw5EtADmN3m_5oMnts",
        subscribe:false,
        disable:false,
        list:[],
        width:0,
        height:0,
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
      var _this = this
      this.getData()
      wx.getStorage({
        key: this.data.template_id,
        success: res=> {
          console.log(res,3333333333)
          _this.setData({
            subscribe: true
          })
        },
      })
    },
    getData(){
        var _this=this;
        f()
        timer=setInterval(f,10000)
        function f(){
          $api.getconsult().then(res=>{
            var nlist = _this.data.list
            
            _this.setData({
                list:res.data.data.list
            })
            
            if(_this.data.list.length > nlist.length){
              _this.scroll()
            }
            
        })
        }
    },
    inputchange(e) {
        this.setData({
            comment: e.detail.value
        })
    },
    subscribe(){
      var template_id = this.data.template_id
      var that = this;
      wx.requestSubscribeMessage({
        tmplIds: [template_id],
        success (res) { 
          if(res[template_id]=='accept'){
            wx.setStorage({
              key: template_id,
              data: "accept",
            })
            that.setData({
              subscribe:true
            })
            that.post()
          }
        }
      })
    },
    post(){
        var data={
          cotent:this.data.comment
        }
        if(!data.cotent){
            return
        }
        this.setData({
          disable:true
        })
        $api.consult(data).then(res=>{
          this.getData()
          this.setData({
            comment:'',
            disable: false
          })
        })
    },
    sendImage(url,width,height){
      var data={
        cotent:url,
        width:width,
        height:height,
      }

      if(!data.cotent){
          return
      }
      this.setData({
        disable:true
      })
      $api.consult(data).then(res=>{
        this.getData()
        this.setData({
          comment:'',
          disable: false
        })
      })
    },

     //预览
    preview(e){
      console.log(e)
      var images = []
      images[0] = e.target.dataset.urls

      wx.previewImage({
        urls: images,
        current: 0
      })
    },
    scroll(){
      let that = this;
      wx.createSelectorQuery().select("#messageScroll").boundingClientRect(function(rect){
        wx.pageScrollTo({
          scrollTop:rect.height,
          duration:100
        })
      }).exec()
    },

    uploadImg(){
      let _this = this;

      wx.chooseImage({
        success: res => {
          wx.showLoading({
            title: '正在上传',
          })
          const tempFilePaths = res.tempFiles
          for (let i = 0; i < tempFilePaths.length; i++) {
            $api.uploadAvatar(tempFilePaths[i].path,'file').then(res=>{
                wx.hideLoading()
                if(res.code == 0){
                  var url = res.data.url
                  wx.getImageInfo({
                    src: tempFilePaths[i].path,
                    success:function(res){
                      _this.sendImage(url,res.width,res.height)
                    }
                  })

                }else{
                  wx.showToast({
                    title: '上传失败',
                  })
                }
            })
            .catch(err=>{
              wx.hideLoading()
            })
          }
  
        }
      })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
      // let that = this;
      // wx.createSelectorQuery().select("#messageScroll").boundingClientRect(function(rect){
      //   wx.pageScrollTo({
      //     scrollTop:rect.height,
      //     duration:100
      //   })
      // }).exec()
    },



    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {
      
    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {
      clearInterval(timer)
    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})